#include <iostream>
#include <numeric>
#include <bits/stdc++.h>
using namespace std;
int funk(int k,int d [],int N)
{
    for(int i=0;i<N;i++)
    {
     if(k==d[i])
            return i;
    }
    return 0;
}
int fun(int k,int p [],int N,int d [])
{
    int br=0;
    int plaz=0;
    for(int i=0;i<k;i++)
    {
        if(funk(i,d,N)!=0)
            plaz+=p[funk(i,d,N)];
        if(plaz>0)
        {
            plaz--;
            br++;
        }
    }
    return br;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int N, Q;
    cin>>N>>Q;
    long long d [N];
    long long p [N];
    long long u;
    for(int i=0;i<N;i++)
        cin>>d[i]>>p[i];
        long long i,br,s,dan;
        int e=Q;
    long long r[Q];
    while(Q>0)
    {
        dan=1;
        i=0;
        br=0;
        s=0;
     cin>>u;
     while(u>0)
     {
         if(d[i]==dan && i<N)
         {
             s+=p[i];
             i++;
         }
         if(s>0)
         {
             br++;
             s--;
         }
         u--;
         dan++;
         if(dan>d[N-1])
         {
             if(s<u)
             br+=s;
             else
             br+=u;
             u=0;
         }
     }
     r[e-Q]=br;
     Q--;
    }
    for(int i=0;i<e;i++)
    {
        cout<<r[i]<<endl;
    }
}